require "sketchup.rb"

def flip_all_x
  sel=Sketchup.active_model.selection
  cis=sel.grep(Sketchup::ComponentInstance)
  gps=sel.grep(Sketchup::Group)
  cis.each {|ci| flip_x(ci)}
  gps.each {|gp| flip_x(gp)}
end 

def flip_x(gp)
  cor=gp.definition.bounds.corner 1
  neworig=gp.transformation*cor
  xrev=gp.transformation.xaxis.reverse
  tmat = gp.transformation.to_a
  tmat[0] = xrev.x
  tmat[1] = xrev.y
  tmat[2] = xrev.z
  tmat[12] = neworig[0]
  tmat[13] = neworig[1]
  tmat[14] = neworig[2]
  gp.transformation = gp.transformation.set!(tmat)
end
